﻿<Window x:Class="TournamentSoftware.Windows.Judge.JudgeWindow"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:local="clr-namespace:TournamentSoftware.Windows.Judge"
        xmlns:o="clr-namespace:TournamentSoftware.Override"
        xmlns:vm="clr-namespace:TournamentSoftware.ViewModels"
        mc:Ignorable="d"
        Closing="Window_Closing"
        Title="Судьи" MinWidth="1250" MinHeight="550">

    <Window.DataContext>
        <vm:JudgeViewModel/>
    </Window.DataContext>

    <Window.Resources>
        <CollectionViewSource x:Key="Clubs" Source="{Binding Clubs}" />
        <CollectionViewSource x:Key="Cities" Source="{Binding Cities}" />
    </Window.Resources>

    <Grid>

        <Grid.ColumnDefinitions>
            <ColumnDefinition/>
            <ColumnDefinition Width="220"/>
        </Grid.ColumnDefinitions>

        <o:EditableDataGrid Grid.Column="0"
                ColumnHeaderStyle="{StaticResource DataGridColumnHeaderStyle}"
                CellStyle="{StaticResource DataGridCellStyle}"
                ItemsSource="{Binding Items}">

            <o:EditableDataGrid.Columns>

                <DataGridCheckBoxColumn Width="30"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderCheckBoxTemplate}"
                        ElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"
                        EditingElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"/>

                <DataGridTextColumn Header="Имя *"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                        Binding="{Binding Data.Name, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"/>

                <DataGridTextColumn Header="Фамилия *"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                        Binding="{Binding Data.Surname, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"/>

                <DataGridTextColumn Header="Отчество"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                        Binding="{Binding Data.Patronymic, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"/>

                <DataGridComboBoxColumn Header="Город"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        ElementStyle="{StaticResource DataGridComboBoxElementStyle}"
                        DisplayMemberPath="Name"
                        ItemsSource="{Binding Source={StaticResource Cities}}"
                        SelectedItemBinding="{Binding Data.City, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"
                        EditingElementStyle="{StaticResource DataGridComboBoxEditingElementStyle}"/>

                <DataGridComboBoxColumn Header="Клуб"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        ElementStyle="{StaticResource DataGridComboBoxElementStyle}"
                        DisplayMemberPath="Name"
                        ItemsSource="{Binding Source={StaticResource Clubs}}"
                        SelectedItemBinding="{Binding Data.Club, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"
                        EditingElementStyle="{StaticResource DataGridComboBoxEditingElementStyle}"/>

                <DataGridCheckBoxColumn Header="Участвует в текущем турнире"
                        Width="*"
                        HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                        Binding="{Binding Data.SelectedForCurrentTournament, UpdateSourceTrigger=PropertyChanged}"
                        ElementStyle="{StaticResource DataGridCheckBoxStyle}"
                        EditingElementStyle="{StaticResource DataGridCheckBoxStyle}"/>
            </o:EditableDataGrid.Columns>

            <o:EditableDataGrid.Style>
                <Style TargetType="DataGrid" BasedOn="{StaticResource DataGridStyle}">
                    <Style.Triggers>
                        <DataTrigger Binding="{Binding DataContext.Tournament.RegistrationCompleted, RelativeSource={RelativeSource Mode=FindAncestor, AncestorType={x:Type Window}}}" Value="True">
                            <Setter Property="IsEnabled" Value="False"/>
                        </DataTrigger>
                    </Style.Triggers>
                </Style>
            </o:EditableDataGrid.Style>

        </o:EditableDataGrid>

        <DockPanel Grid.Column="1"
                Style="{StaticResource PanelSettingsStyle}">

            <Button Content="Добавить"
                    Command="{Binding AddItemCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"
                    DockPanel.Dock="Top"/>

            <Button Content="Удалить"
                    Command="{Binding RemoveItemsCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"
                    DockPanel.Dock="Top"/>

            <Button Content="Сохранить"
                    Command="{Binding SaveDataCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"
                    DockPanel.Dock="Top"/>

        </DockPanel>
    </Grid>
</Window>